module GROUP
   implicit  none
   public :: GCD

contains

!! This function computes the greatest common divisor of the two given integers.
recursive  function  GCD (M, N) result (G)

   integer, intent (in)            :: M, N
   integer                         :: G

   if (N == 0) then
      G = M
   else
      G = GCD (N, modulo (M, N) )
   end  if

end  function  GCD

!! Figure 2.6  Algorithm for determining the greatest common denominator of two numbers

end  module  GROUP
