module Node_Definition
   implicit  none
   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   !! The following is a dual, recursive, derived type definition.                   !!
      type, public                                :: Aux_Ptr                         !!
         type (Node), pointer                     :: Aux                             !!
      end  type  Aux_Ptr                                                             !!
      type, public                                :: Node                            !!
         integer                                  :: Item                            !!
         logical                                  :: Color                           !!
         type (Node), pointer                     :: Parent                          !!
         type (Aux_Ptr), dimension ( : ), pointer :: D                               !!{XE "array: of pointers"}
      end  type  Node                                                                !!
   !! End of dual, recursive, derived type definition.                               !!
   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      type (Node), pointer, public                :: Current
      integer, parameter, public                  :: Right = 1, Left = 0

end module  Node_Definition