   program  COM
      implicit  none
      complex                      :: C, D, E, S
      real                         :: R, U

      D = (1.0, 1.0)                              !! Example of a complex constant.
      E = 1.0                                     !! Example of a conversion from a real
                                                  !! constant to a complex value.
      C = conjg (D)                               !! Forms the complex conjugate of D.
      print *, C
      C = D + E                                   !! Form the sum of complex numbers D and E
      print *, C                                  !! Prints one complex number.
      read *, R, U                                !! Reads in two real values.
      C = cmplx (R, U)                            !! Forms a complex number with R as the
                                                  !! real part, and U as the imaginary part.
      print *, C
      R = real (C)                                !! Extracts the real part of C.
      U = aimag (C)                               !! Extracts the imaginary part of C.
      print *, R, U
      read *, D, E
      C = D - E                                   !! Forms the difference between two complex
                                                  !! numbers.
      C = D*E                                     !! Forms the product of two complex numbers.
      C = D/E                                     !! Divides two complex numbers.
      print *, C
      S = sqrt (C)                                !! Forms the square root of a complex number.
      print *, "The square root of ", C, " is ", S
   end  program  COM

!! Figure 4.1  A program illustrating the uses of built-in functions for complex numbers
