   module  Defined_Type
      type, public                 :: Customer
         character (len=20)        :: Name
         character (len=20)        :: Street
         character (len=20)        :: Suburb
         character (len=4)         :: Postcode
         integer                   :: Home_Tel_No
         integer                   :: Work_Tel_No
      end  type   Customer
   end module  Defined_Type

   !! This program reads in the records of a sequential file and prints the details of each
   !! client as held in the record.
   program  SHOW
      use  Defined_Type
      implicit  none
      type (Customer)              :: Consumer
      integer                      :: Status

      open (unit=8, file="CLIENTS", form="unformatted", action="read", status="old" )

      do
         read (unit=8, iostat=Status) Consumer
         if (Status < 0) then
            exit
         end  if
         print *
         print *, Consumer%Name
         print *, Consumer%Street
         print *, Consumer%Suburb, Consumer%Postcode
         print *, Consumer%Home_Tel_No, Consumer%Work_Tel_No
      end  do

   end  program  SHOW

!! Figure 7.1  Reading an unformatted file
