module HEX2BIN_MODULE
   implicit none
   public :: HEX2BIN

contains

   !! This function converts the argument from hexadecimal, and returns the equivalent binary integer.
   function  HEX2BIN (String) result (Number)
      character (len=*), intent (in) :: String
      integer                        :: Number

      integer                        :: J
      character (len=1)              :: Ch

      Number = 0
      do  J = 1, len(String)
         Ch = String(J:J)

         select  case (Ch)
            case ("0" : "9")
               Number = Number * 16 + ichar(Ch) - ichar ("0")
            case ("a": "f")
               Number = Number * 16 + ichar(Ch) - ichar ("a") + 10
            case ("A": "F")
               Number = Number * 16 + ichar(Ch) - ichar ("A") + 10
            case  default
               exit
         end  select

      end  do

   end  function  HEX2BIN

end  module  HEX2BIN_MODULE

