MODULE  SALFORD
   IMPLICIT  NONE
   !! The Salford colors are:
   INTEGER, PARAMETER :: Color_Back = 0, Color_Blue = 1, Color_Green = 2, Color_Cyan = 3, &
                         Color_Red = 4, Color_Magenta = 5, Color_Brown = 6,               &
                         Color_White = 7, Color_Dark_Grey = 8, Color_Light_Blue = 9,      &
                         Color_Light_Green = 10, Color_Light_Cyan = 11,                   &
                         Color_Light_Red = 12, Color_Light_Magenta = 13,                  &
                         Color_Yellow = 14, Color_Intense_White = 15
   INTERFACE
      !! Definitions for Salford Graphics.
      SUBROUTINE  VGA@                            !! For high-density graphics, 640 x 480, 16 colors.
      END  SUBROUTINE  VGA@
      SUBROUTINE  EGA@                            !! For low-density graphics, 640 x 350, 16 colors.
      END  SUBROUTINE  EGA@
      SUBROUTINE  TEXT_MODE@
      END  SUBROUTINE  TEXT_MODE@
      SUBROUTINE  GET_KEY@ (Key)
         IMPLICIT  NONE
         INTEGER                   :: Key
      END  SUBROUTINE  GET_KEY@
      SUBROUTINE  GET_PIXEL@ (Ix, Iy, Color)
         IMPLICIT  NONE
         INTEGER                   :: Ix, Iy, Color
      END  SUBROUTINE  GET_PIXEL@
      SUBROUTINE  SET_PIXEL@ (Ix, Iy, Color)
         IMPLICIT  NONE
         INTEGER                   :: Ix, Iy, Color
      END  SUBROUTINE  SET_PIXEL@
      SUBROUTINE  DRAW_LINE@ (Ix_Start, Iy_Start, Ix_Finish, Iy_Finish, Color)
         IMPLICIT  NONE
         INTEGER                   :: Ix_Start, Iy_Start, Ix_Finish, Iy_Finish, Color
      END  SUBROUTINE  DRAW_LINE@
      SUBROUTINE  DRAW_TEXT@ (Text, Ix, Iy, Color)
         IMPLICIT  NONE
         CHARACTER (LEN=*)         :: Text
         INTEGER                   :: Ix, Iy, Color
      END  SUBROUTINE  DRAW_TEXT@
   END  INTERFACE
END  MODULE  SALFORD

