program MAXIMUMS
   implicit  none
   integer, dimension (4, 3)       :: B
   integer, dimension (4)          :: Row_Maximums
   integer, dimension (3)          :: Column_Maximums
   integer                         :: J

   B = reshape (  source = (/ 3, 5, 2,                &
                     4, 3, 5,                &
                     1, 3, 6,                &
                     5, 0, 2     /),            &
                              shape = shape(B), &
                              pad = (/ 0 /),    &
                              order = (/ 2, 1 /) )

   Row_Maximums   = maxval (B, 2)
   Column_Maximums   = maxval (B, 1)

   write (unit=*, fmt="(tr13, a)" ) "Row maximums"
   do J = 1, 4
      write (unit=*, fmt="(4i4)" ) B(J, : ), Row_Maximums(J)
   end  do

   write (unit=*, fmt="(3i4, a)" ) Column_Maximums, " <<<<- Column maximums"

end  program  MAXIMUMS

!! Figure 12.1  Illustration of maxval
