module GROUP
   implicit  none
   public :: FACTORIAL

contains

   recursive  function  FACTORIAL (N) result (F)
      integer, intent(in)          :: N
      real                         :: F

      if (N <= 1) then
         F = 1
      else
         F = N * FACTORIAL(N-1)
      end  if

   end  function  FACTORIAL

!! Figure 2.1  A recursive function procedure for evaluating factorials

end  module  GROUP
