module GROUP
   implicit  none
   public :: FIBONACCI
   integer, parameter, public :: Double = selected_real_kind(14)

contains

!! This function calculates the N-th term of the Fibonacci series, N >= 1.
recursive  function  FIBONACCI (N) result (F)

   integer, intent (in)            :: N
   real (kind=Double)              :: F

   if (N <= 2) then
      F = 1
   else
      F = FIBONACCI(N-1) + FIBONACCI(N-2)
   end  if

end  function  FIBONACCI

!! Figure 2.4  Algorithm for generating Fibonacci numbers

end  module  GROUP
