module GROUP
   implicit  none
   public :: PRODUCT_OF

contains

!! This function forms the product of two positive integers.
recursive  function  PRODUCT_OF (M, N) result (P)

   integer, intent (in)            :: M, N
   integer                         :: P

   if (M <= 1) then
      P = N
   else if (N <= 1) then
      P = M
   else
      P = M + N - 1 + PRODUCT_OF (M-1, N-1)
   end  if

end  function  PRODUCT_OF

!! Figure 2.5  Algorithm to multiply two numbers without using multiplication

end  module  GROUP
