module  GROUP
   implicit  none
   public :: TRAVERSE

contains

recursive  subroutine  TRAVERSE (Current)
   !! INCOMING: Current = a pointer to the root of a tree or subtree.
   use  DEFINE_NODE
   type (Node), pointer            :: Current

   if (associated (Current%Left) ) then           !! Take the left-hand path . . .
      call TRAVERSE (Current%Left)
   end  if

   write (unit=*, fmt="(i11)", advance="no" ) Current%Value

   if (associated (Current%Right) ) then          !! Take the right-hand path.
      call TRAVERSE (Current%Right)
   end  if

end  subroutine  TRAVERSE

!! Figure 3.6  Traversing a binary tree

end  module  GROUP
