!! This program will compute the N complex N-th roots of a complex number, using
!! de Moivre's theorem.
program  ROOTS
   implicit  none
   complex                         :: Z, Root
   real                            :: Theta, Angle, R
   integer                         :: K, N
   real, parameter                 :: PI = 3.14159

   print *, "Please type the complex number whose roots are desired:"

   read *, Z
   print *, "Please type the number of roots:"
   read *, N
   print *, "The ", N, "-th roots of ", Z, "are:"
   R = abs(Z)                                     !! which calculates sqrt(x**2 + y**2), where Z = x + iy.
   Theta = atan2 (aimag(Z), real(Z))

   do K = 0, N-1
      Angle = (Theta + 2*K*PI)/N
      Root = R**(1.0/N) * cmplx (cos(Angle), sin(Angle) )
      print *, "Root number ", K, " is ", Root
   end  do

end  program  ROOTS

!! Figure 4.2  A program to compute the  n roots of a complex number
