module GROUP
   implicit  none
   public                          :: FOUR1
   interface
      subroutine  FOUR1 (F, N, Direction_Sign)
         complex, dimension ( : ), intent (in out) :: F
         integer, intent (in)             :: N, Direction_Sign

      end  subroutine  FOUR1
   end  interface

end  module  GROUP

program  FFT
   use  GROUP
   implicit  none
   integer                         :: N

   complex, dimension ( : ), allocatable  :: F
   integer                         :: J, Direction_Sign

   print *, "This program performs a Fast Fourier Transform."
   print *, "How many observations are there?"
   read *, N

   allocate (F(N) )

   print *, "Please type the", N, " coefficients:"
   do J = 1, N
      print *, "Please type coefficient", J
      read *, F(J)
      print *, F(J)
   end  do

   Direction_Sign = 1
   call FOUR1 (F, N, Direction_Sign)

   do J = 1, N
      write (unit=*, fmt="(2f15.6)" ) F(J)
   end  do

end  program  FFT

!! Figure 5.2  A program to call the Fast Fourier Transform procedure of Figure 5.1
